<?PHP

/* ====================
Seditio - Website engine
Copyright Neocrome
http://www.neocrome.net

[BEGIN_SED]
File=plugins/topblog/topblog.php
Version=100
Updated=2006-jan-24
Type=Plugin
Author=Neocrome
Description=
[END_SED]

[BEGIN_SED_EXTPLUGIN]
Code=topblog
Part=main
File=topblog
Hooks=list.tags
Tags=list.tpl:{PLUGIN_BLOG.categorycodehere}
Minlevel=0
Order=10
[END_SED_EXTPLUGIN]

==================== */

if (!defined('SED_CODE')) { die('Wrong URL.'); }

/* ============ MASKS FOR THE HTML OUTPUTS =========== */

$cfg['plu_mask_topblog'] = "%1\$s"." ".$cfg['separator']." "."%2\$s"." ".$cfg['separator']." "."%3\$s"." (%4\$s )<br>
";
// %1\$s = Link to the category
// %2\$s = Link to the page
// %3\$s = Date
// %4\$s = Desc

$plu_empty = $L['None']."<br />";

		
function sed_get_topblog($c, $limit, $mask)
	{
	global $L, $db_pages, $db_users, $usr, $cfg, $sed_cat, $sed_catacc, $plu_empty;

	$mtch = $sed_cat[$c]['path'].".";
	$mtchlen = strlen($mtch);
	$catsub = array();
	$catsub[] = $c;

	@reset($sed_cat);
	while (list($i,$x) = each($sed_cat) )
		{
		if (substr($x['path'],0,$mtchlen)==$mtch)
			{
			$catsub[] = $i;
			}
		}

	$sql = sed_sql_query("SELECT p.page_id,p.page_cat,p.page_title,p.page_ownerid,p.page_count,p.page_alias,u.user_name,u.user_id FROM $db_pages AS p
		LEFT JOIN $db_users AS u on u.user_id=p.page_ownerid
		WHERE page_state=0
		AND page_cat NOT LIKE 'system'
		AND page_cat IN ('".implode("','", $catsub)."')
		ORDER by page_count DESC LIMIT $limit");
		
	while ($row = sed_sql_fetcharray($sql))
		{
		$row['page_urlpar'] = (empty($row['page_alias'])) ? "id=".$row['page_id'] : "al=".$row['page_alias'];

		$res .= (sed_auth('page', $row['page_cat'], 'R')) ? sprintf($mask,
			"<a href=\"list.php?c=".$c."&s=date&w=desc&o=ownerid&p=".$row['page_ownerid']."\">".sed_cc($row['user_name'])."</a>",
			"<a href=\"list.php?c=".$row['page_cat']."\">".$sed_cat[$row['page_cat']]['title']."</a>",
			"<a href=\"page.php?".$row['page_urlpar']."\">".sed_cc(sed_cutstring(stripslashes($row['page_title']),36))."</a>",
			sed_cc($row['page_count'])
				) : '';
		}

	$res = (empty($res)) ? $plu_empty : $res;

	return($res);
	}


if ($cfg['plugin']['topblog']['maxpages']>0 && !empty($cfg['plugin']['topblog']['categories']))
	{
	$cats = explode(',', $cfg['plugin']['topblog']['categories']);
	foreach($cats as $k => $i)
		{
		$i = trim($i);
		$topblog[$i] = sed_get_topblog(
			$i,
			$cfg['plugin']['topblog']['maxpages'],
			$cfg['plu_mask_newpagesbypath']);
		}
	}

$t-> assign(array(
	"PLUGIN_BLOG" => $topblog,
	"PLUGIN_BLOG_MAXLINES" => $cfg['plugin']['topblog']['maxpages']
		));

?>